#   Hinawa Battle Engine
##  Earthbound/Mother 3 inspired battle engine
##  By Eiyeron

### Tempoary licence : [Creative Commons 4.0 CC-BY](http://creativecommons.org/licenses/by/4.0/)
Explanation : You can use this engine, share it, transform it or do something with it and even sell your product, but with two terms:
    - You need to credit me : Eiyeron Fulmicendii with link to [@Eiyeron](https://twitter.com/Eiyeron) (Twitter) or [+EiyeronFulmincendii](https://plus.google.com/+EiyeronFulmincendii) (G+). Give a link to [GeekBros](http://geekbros.tk) if you want (but the site is still in deep WIP.)
        + You need too to indcate the changes you made
    - Don't add any restriction from the one I gave.

### Abstract
This engine is a work in progress port of the semi-turn based RPG battle engine that runs in Earthbound and Mother 3, two excellent games for Itoi Shigesato. This is intended to run as an independant program from a RPG engine, giving some sort of API to give it data, sprites, scripts to make the battle more living

### Using this in a project
Avoid using it at the moment, it's still in deep WIP, I almost changed again the battle workflow but I decided to stick with that one because I saw that I could edit it without breaking it as I did before when addind death dectection

### Technical
The engine is semi-turn based. The battle itself is turn based, but the life and magic rolling meters are rolling in real time, giving a stress and real time factor to the game. This part of the game changes almost everything from a classical TRPG engine in a way that it needs a coroutine-like update/draw loop to update all the realtime factors in the game, as the rolling meters but the background too!

I'll write later the formulas I got from Earthbound, the ones for Mother 3 are imprecise or almost inexistant on the Interpipes, so I guess I'll stick with EB or the moment.

Writing about the used variables is planned too, just wait a little, I need to list them and read my docs.

#### What's made and what to do?
#####What's done
- Player character number, up to 4 (needs to correct that in some places, I assumed that there were 4 characters all the time)
- Updating rolling meters in realtime
- Updating background in realtime
- Basic text routines with almost working word wrap and variable width font! (like in Mother 3! :3 )
- Death detection
- WIP battle UI
- Displaying the ennemy with compressed and chunked sprite

#####What's to do
- Actual attack system. At this moment, you can only die.
- Damage formula
- Adding at least Mr Batty stats to emulate a fight
- Status Ailment
- Finish UI
- Add PSI/special competence (you maybe won't have PSI and Sniff/Thief capacities in your game! But I'll do a way to make your customisation easier, I think)
- Objects
- Better text routines : control character based string manipulation (add the 4's character player here, display the current attack there, etc...). Will be harder than thought.
- OPTIMIZE ALL THE PROGRAM
- Losing the Game
- Documentation (a lot, a lot)
- Boing! Zoom!

#### Scripting?
I'd like to implement scripting. This is based on triggers, like an ennemy getting under XX% HP, or after 3 turns. This would trigger some reactions (like choosing another attack or popping a textbox). I have some ideas about the scripts itselves but none about their implementations. This could add a big speed loss but could add a definitive advantage to this engine (I think to give to the engine function's addresses for triggering them at the right moment, or parsing some kind of simplistic scripting language). At the end I want to be able to at least, reproduce all dorts of events that occurs in M3 (from the penultiame textbox which appears nowhere else to Rhinocerocket's suicide or even NK Cyborg's End of Century Beam.)

#### Background
Yeah, I want too to bring back Earthbound/Mother 3's sillyness right in our calcs. Background could only be fast hardly optimized routines to display some sort of graphical eyecandy(Rock).

### Thanks
I'd like to thanks a lot of persons:
- Quigibo for its Axe Parser, the best low-level programming language ever.
- Runer112 for supporting Axe Parser and being an Axe God.
- Sorunome, a great supporting friend. Don't give up dude! ;)
- Siapran, almost a brother. The Game, dude, the game.
- [Clyde Mandelin](http://legendsoflocalization.com/), author of the [Mother 3 English traduction patch](http://mother3.fobby.net/) and writer of the blog [Earthbound Central](earthboundcentral.com). A day, I got a supporting tweet from a stranger. After some fast investigations, it looked like Clyde (Mato) [found out](http://earthboundcentral.com/2013/10/mother-3-calculator-edition/) about my project! And the post definitely needs some update! :p

Enjoy!

Eiyeron Fulmincendii
~Like A Phoenix - IAYD